 /* 
      ॠ樨    ࠪ⭮  ⨯    
    "᭮- ॢ".            
    -------------------------------------------------
    : ..筨, , 2   (21.11.2012) 
 */
   struct node
      {
        int Key;              /* ଠ樮                  */
        int Count;            /* 稪 ७ ⮢        */
        unsigned Color;       /*  㧫 (0 - , 1 - ) */
        struct node *Left;    /* ⥫   "뭠"          */
        struct node *Right;   /* ⥫  ࠢ "뭠"         */
        struct node *Parent;  /* ⥫  ""                 */
      };
   struct node Sentinel={0,0,0,NULL,NULL,NULL};


   struct node *BuildTree(struct node *Tree)
 /* 
    ஥ ᭮-୮ ॢ,  
    㪠⥫ Tree  設 ॢ             
    -------------------------------------------
 */
   {
      int el;
      Tree=NIL; 
      printf("  設 ॢ: "); scanf("%d",&el);
      while (el)
      {
        Search(el,&Tree,NULL); scanf("%d",&el);
        while(Tree->Parent)
          Tree=Tree->Parent;
      }
      return Tree;
   }
 
   
   struct node *BuildTreeRand(struct node *Tree)
 /*
    ஥ "砩" ᭮-୮ ॢ, 
     㪠⥫ Tree  設 ॢ      
    ----------------------------------------------
 */
   {
      int el=rand()%M;
      Tree=NIL;
      while (el)
      {
        Search(el,&Tree,NULL); el=rand()%M;
        while(Tree->Parent)
          Tree=Tree->Parent;
      }
      return Tree;
   }

   void Search(int x,struct node **Tree,struct node *P)
 /* 
      x  ᭮-୮ ॢ ( 㪠- 
     *Tree  設 ॢ)   祭.  P - 㪠-
    ⥫  ""                 
    ------------------------------------------------------- 
 */
   {
      if (*Tree==NIL || !*Tree)
      {
        *Tree=(struct node *) calloc(sizeof(struct node),1);
        (*Tree)->Key=x; (*Tree)->Count=1;
        (*Tree)->Left=NIL; (*Tree)->Right=NIL;
        (*Tree)->Parent=P;
        (*Tree)->Color=RED;
        Balance(*Tree);
      }
      else if (x<(*Tree)->Key)
          Search(x,&((*Tree)->Left),*Tree);
        else if (x>(*Tree)->Key)
          Search(x,&((*Tree)->Right),*Tree);
        else (*Tree)->Count+=1;
   }


   struct node *Insert(struct node *Tree,int k)
 /*
    祭  k  ᭮-୮ ॢ, 
    㪠⥫ Tree
    --------------------------------------------------
 */ 
   {
        Search(k,&Tree,NULL);
        while(Tree->Parent)
          Tree=Tree->Parent;
        return Tree;
   } 

   
   void PrintTree(struct node *Tree,int l)
 /* 
    ࠦ ୮ ॢ ᪠,  㪠⥫ 
    Tree,  ࠭ ᯫ. ࠬ l  맮 ࠢ 0    
    --------------------------------------------------------- 
 */
   {
      int i;
      if (Tree!=NIL)
      {
        PrintTree(Tree->Right,l+1);
        for (i=1;i<=l;i++)
          printf("   ");
        printf("%d",Tree->Key);
        if(Tree->Color)
          printf("(R)\n");
        else
          printf("(B)\n");
        PrintTree(Tree->Left,l+1);
      }
   }


   struct node *Uncle(struct node *T)
 /* 
    㭪 頥 㪠⥫  "" , 
     㪠⥫ T
    --------------------------------------------- 
 */
   {
     if (T->Parent && T->Parent->Parent)
     {
       if (T->Parent==T->Parent->Parent->Left)
         return T->Parent->Parent->Right;
       else
         return T->Parent->Parent->Left;
     }
     return NULL;
   }

   
   void Balance(struct node *Tree)
 /* 
    ஢ ᭮-୮ ॢ, 室 
     . Tree - 㪠⥫       
    --------------------------------------------------- 
 */
   {
     struct node *grand,*unc;
     if(!Tree->Parent)
       Tree->Color=BLACK;
     else
     {
       grand=Tree->Parent->Parent;
       unc=Uncle(Tree);
       if(Tree->Parent->Color)
       {
         if(unc && unc->Color && Tree->Parent->Color)
         {
           Tree->Parent->Color=BLACK;
           unc->Color=BLACK;
           grand->Color=RED;
           Balance(grand);
         } 
         else
         {
            if((Tree==Tree->Parent->Right)
                   &&(Tree->Parent==grand->Left))
            { 
              RotateLeft(Tree->Parent);
              Tree=Tree->Left;
              grand=Tree->Parent->Parent;
              unc=Uncle(Tree);      
            } 
            else if((Tree==Tree->Parent->Left)
                         &&(Tree->Parent==grand->Right))
              {
                RotateRight(Tree->Parent);
                Tree=Tree->Right;
                grand=Tree->Parent->Parent;
                unc=Uncle(Tree);
              }
            Tree->Parent->Color=BLACK;
            grand->Color=RED;
            if((Tree==Tree->Parent->Left)&&(Tree->Parent==grand->Left))
              RotateRight(grand);
            else
              RotateLeft(grand);
         } 
       }
     } 
   }


   void RotateLeft(struct node *T)
 /* 
     饭 ॢ  設,  
    㪠⥫ T
    ----------------------------------------- 
 */
   {
     if(T && T->Right!=NIL)
     {
       if(T->Parent) 
       { 
         if(T==T->Parent->Right)
           T->Parent->Right=T->Right;
         else 
           T->Parent->Left=T->Right;
       }
       T->Right->Parent=T->Parent;
       T->Parent=T->Right;
       T->Right=T->Parent->Left;
       if(T->Right!=NIL)
         T->Right->Parent=T;
       T->Parent->Left=T;
     }
   }    	
   
   
   void RotateRight(struct node *T)
 /* 
    ࠢ 饭 ॢ  設,  
    㪠⥫ T
    ----------------------------------------- 
 */
   { 
     if(T && T->Left!=NIL)
     {
       if(T->Parent) 
       { 
         if(T==T->Parent->Right)
           T->Parent->Right=T->Left;
         else 
           T->Parent->Left=T->Left;
       }
       T->Left->Parent=T->Parent;
       T->Parent=T->Left;
       T->Left=T->Parent->Right;
       if(T->Left!=NIL)
         T->Left->Parent=T;
       T->Parent->Right=T;
     }
   }


   void CleanTree(struct node **w)
 /* 
    ⪠ ॢ (  㪠⥫ *w  
    ७ ॢ), 稭  楢 設
    ------------------------------------------- 
 */
   {
      if (*w!=NIL)
      {
        CleanTree(&((*w)->Left)); CleanTree(&((*w)->Right));
        free(*w);
      }
   } 


   struct node *Delete(struct node *Tree,int k)
 /*
     設 k  ୮ ॢ ᪠, 
      㪠⥫ *Tree   ७  ॢ 
    (頥 㪠⥫  ७)
    ----------------------------------------------   
 */
   {
        Delete_1(&Tree,k);
        while(Tree->Parent)
          Tree=Tree->Parent;
        return Tree;
   } 


   void Delete_1(struct node **Tree,int k)
 /*
     設 k  ୮ ॢ ᪠, 
      㪠⥫ *Tree   ७  ॢ 
    ( 頥 㪠⥫  ७)
    ----------------------------------------------   
 */
   {
      struct node *q;
      if (*Tree==NIL)
        printf("  .\n");
      else if (k<(*Tree)->Key)
          Delete_1(&((*Tree)->Left),k);
        else if (k>(*Tree)->Key)
          Delete_1(&((*Tree)->Right),k);
        else 
        {
          q=*Tree;
          if (q->Right==NIL)
          {
            q->Left->Parent=(*Tree)->Parent;
            if(!(*Tree)->Color)
            {
              *Tree=q->Left;
              if(q->Left->Color)
                q->Left->Color=BLACK;
              else if(!q->Left->Color)
                Balance1(*Tree);
            } 
            else
              *Tree=q->Left;
            free(q);
          }
          else if (q->Left==NIL)
          {
            q->Right->Parent=(*Tree)->Parent;
            if(!(*Tree)->Color)
            {
              *Tree=q->Right;
              if(q->Right->Color)
                q->Right->Color=BLACK;
              else if(!q->Right->Color)
                Balance1(*Tree);
            }
            else
              *Tree=q->Right;
            free(q);
          }
          else Delete_2(&(q->Left),&q);
        }
   }


   void Delete_2(struct node **r,struct node **q)
 /* 
    ⥫쭠  㭪    㭪樨  Delete_1
    -----------------------------------------------
 */
   {
     struct node *s;
     if ((*r)->Right==NIL)
     {           
       (*q)->Key=(*r)->Key; (*q)->Count=(*r)->Count;
       *q=*r; s=*r; *r=(*r)->Left;
       Delete_1(&s,s->Key);    
     }
     else Delete_2(&((*r)->Right),q);
   }
  

   void Balance1(struct node *Tree)
 /* 
    ஢ ᭮-୮ ॢ, 室 
    㤠 . Tree - 㪠⥫       
    --------------------------------------------------- 
 */
   {
     struct node *bro;
     if(Tree->Parent)
     {
       if (Tree==Tree->Parent->Left)
         bro=Tree->Parent->Right;
       else
        bro=Tree->Parent->Left;
       if(bro->Color)
       {
         bro->Parent->Color=RED;
         bro->Color=BLACK;
         if(Tree==Tree->Parent->Left)
         {
           RotateLeft(Tree->Parent);
           bro=Tree->Parent->Right;
         }
         else
         {
           RotateRight(Tree->Parent);
           bro=Tree->Parent->Left;
         }
       }
       if(!Tree->Parent->Color && !bro->Color &&
                             !bro->Left->Color &&
                                !bro->Right->Color)
       {
         bro->Color=RED;
         Balance1(Tree->Parent);
       }
       else 
       {
         if(Tree->Parent->Color  && !bro->Color &&
                                !bro->Left->Color &&
                                     !bro->Right->Color)
         {
           bro->Color=RED;
           Tree->Parent->Color=BLACK;
         }
         else 
         {
           if(!bro->Color)
           {
             if(Tree==Tree->Parent->Left &&
                          bro->Left->Color &&
                                 !bro->Right->Color)
             {
               bro->Color=RED;
               bro->Left->Color=BLACK;
               RotateRight(bro);
               bro=Tree->Parent->Right;
             }
             else if(Tree==Tree->Parent->Right  &&
                                bro->Right->Color &&
                                          !bro->Left->Color)
             {                    
               bro->Color=RED;
               bro->Right->Color=BLACK;
               RotateLeft(bro);
               bro=Tree->Parent->Left;
             }
             bro->Color=Tree->Parent->Color;
             Tree->Parent->Color=BLACK;
             if(Tree==Tree->Parent->Left)
             {
               bro->Right->Color=BLACK;   
               RotateLeft(Tree->Parent);
             }
             else
             {
               bro->Left->Color=BLACK;   
               RotateRight(Tree->Parent);                        
             }
           }
         }
       }
     }
   }
